hdu 1429 胜利大逃亡(续) bfs+状态压缩
来源:程序员人生 发布时间:2015-03-20 08:25:56 阅读次数:2552次
成功大流亡(续)
Time Limit: 4000/2000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 5738 Accepted Submission(s): 2006
Problem Description
Ignatius再次被魔王抓走了(弄不懂他咋这么讨魔王喜欢)……
这次魔王汲取了上次的教训,把Ignatius关在1个n*m的地牢里,并在地牢的某些地方安装了带锁的门,钥匙藏在地牢另外的某些地方。刚开始Ignatius被关在(sx,sy)的位置,离开地牢的门在(ex,ey)的位置。Ignatius每分钟只能从1个坐标走到相邻4个坐标中的其中1个。魔王每t分钟回地牢视察1次,若发现Ignatius不在原位置便把他拎回去。经过若干次的尝试,Ignatius已画出全部地牢的地图。现在请你帮他计算能否再次成功流亡。只要在魔王下次视察之前走到出口就算离开地牢,如果魔王回来的时候恰好走到出口或还未到出口都算流亡失败。
Input
每组测试数据的第1行有3个整数n,m,t(2<=n,m<=20,t>0)。接下来的n行m列为地牢的地图,其中包括:
. 代表路
* 代表墙
@ 代表Ignatius的起始位置
^ 代表地牢的出口
A-J 代表带锁的门,对应的钥匙分别为a-j
a-j 代表钥匙,对应的门分别为A-J
每组测试数据之间有1个空行。
Output
针对每组测试数据,如果可以成功流亡,请输出需要多少分钟才能离开,如果不能则输出⑴。
Sample Input
4 5 17
@A.B.
a*.*.
*..*^
c..b*
4 5 16
@A.B.
a*.*.
*..*^
c..b*
Sample Output
16
⑴
Author
LL
做法:由于钥匙最多有10把,2^10 =1024,所以可以把10把钥匙有无的情况记录在 1个数中。 num的第3维就是 钥匙 具有的状态。然后就和普通的bfs1样了。
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;
#include <stack>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
using namespace std;
int n,m,t;
char mp[22][22];
int num[22][22][1050];//位置 钥匙状态
int dir[4][2]={⑴,0,1,0,0,1,0,⑴};
int ex,ey;
int stax,stay;
struct point
{
int x,y,step,key;
};
int ok(int x,int y)
{
if(!(x>=0&&x<n&&y>=0&&y<m))
return 0;
char ch=mp[x][y];
if(ch<='J'&&ch>='A')
return 3; //门
if(ch<='j'&&ch>='a')
return 2; //key
if(ch!='*')
return 1;
return 0;
}
int bfs()
{
if(t==0)
return ⑴;
point sta,now,tem;
sta.x=stax;
sta.y=stay;
sta.step=0;
sta.key=0;
queue<point> q;
q.push(sta);
while(!q.empty())
{
now=q.front();
q.pop();
if(now.step!=0&&now.step%t==0)
{
return ⑴;
//now.x=stax;
//now.y=stay;
}
if(now.x==ex&&now.y==ey)
return now.step;
for(int i=0;i<4;i++)
{
int xx=now.x+dir[i][0];
int yy=now.y+dir[i][1];
int cdt=ok(xx,yy);//condition
int key=now.key;
if(cdt==0)
continue;
if(cdt==3&&(key&(1<<(mp[xx][yy]-'A')))==0)
continue;
if(cdt==2)
key|=(1<<(mp[xx][yy]-'a'));
if(num[xx][yy][key]==⑴||num[xx][yy][key]>now.step+1)
{
tem.x=xx;
tem.y=yy;
tem.step=now.step+1;
tem.key=key;
num[xx][yy][key]=now.step+1;
q.push(tem);
}
}
}
return ⑴;
}
int main()
{
while(scanf("%d%d%d",&n,&m,&t)!=EOF)
{
memset(num,⑴,sizeof num);
for(int i=0;i<n;i++)
scanf("%s",mp[i]);
for(int i=0;i<n;i++)
{
for(int j=0;j<m;j++)
{
if(mp[i][j]=='@')
stax=i,stay=j;
if(mp[i][j]=='^')
ex=i,ey=j;
}
}
printf("%d
",bfs());
}
return 0;
}
生活不易,码农辛苦
如果您觉得本网站对您的学习有所帮助,可以手机扫描二维码进行捐赠